#!/usr/bin/perl

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use CGI::EncryptForm;
use Mail::SendEasy;
use String::SetUTF8;
use IO::Handle;
use GnuPG::Interface;
use GnuPG::Handles;
use Crypt::SMIME;
use Email::Send;
use FileUpload::Filename;
use Date::Format qw(time2str);
use Mail::Builder;

use integer;

$query = new CGI;

# The default main directory
my $maindir= '/privacybox/';


# max size for attachements
my $attachement_max_size= 600;

# Message translations
my %messages = (
     de => [ 'Unbekannter Empf&#228;nger!',
             'Das Postfach von ist voll, es können keine Nachrichten mehr gespeichert werden.',
             'Bitte geben Sie einen kurzen &#034;Betreff&#034; für die Nachricht an.',
             'Die Nachricht enth&#228;lt keinen Text!',
             'Interner Fehler!<br>Die Nachricht wurde NICHT gespeichert.',
             'Die Nachricht wurde gespeichert.',
             'Die Nachricht wurde NICHT gespeichert!<br>Der Name der angeh&#228;ngten Datei ist suspect, bitte benennen Sie die Datei um und senden Sie die Nachricht erneut.',
             'Das Postfach ist noch nicht konfiguriert! Es werden keine Nachrichten angenommen.',
             'Zeit&#252;berschreitung, die Nachricht wurde NICHT gespeichert.',
             'Fehlerhafte Daten gesendet!',
             #10
             'Empf&#228;nger',
             'Mobile-Version',
             'Betreff',
             'Desktop-Version',
             'Text der Nachricht',
             'Datei anh&#228;ngen',
             'max. 600kB',
             'Nachricht senden',
             'PrivacyBox',
             'Wird unverschl&#252;sselt gespeichert!',
             # 20
             'Wird mit OpenPGP oder S/MIME verschl&#252;sselt.',
             'Die Nachricht wird anonym gespeichert. Bitte geben Sie im Text der<br>Nachricht eine <strong>Kontaktadresse</strong> an, wenn Sie eine Antwort erwarten.',
             'Die Software erkennt OpenPGP-konform verschl&#252;sselte Texte und Anh&#228;nge und wird diese nicht zus&#228;tzlich verschl&#252;sseln. Wenn Sie einen OpenPGP-Schl&#252;ssel des Empf&#228;ngers im Keyring haben, nutzen Sie die M&#246;glichkeit, den Text und den Anhang selbst zu verschl&#252;sseln. Eine kurze Anleitung f&#252;r <a href="https://www.awxcnx.de/handbuch_32q.htm" target="_blank">den Nachrichtentext</a> und <a href="https://www.awxcnx.de/handbuch_35p.htm" target="_blank">die Anh&#228;nge</a> stellen wir bereit.',
             'Scheinbar versuchen Sie, eine HTML-Mail zu faken.',
             'Die Nachricht enth&#228;lt unzul&#228;ssige HTML-Tags.',
             'Wird f&#252;r diesen Empf&#228;nger nicht verschl&#252;sselt.',
             'Bescheibung',
             'Anmelden',
             'Login',
             'Kontakt',
             # 30
             'Tor-Web-Proxy',
             'mehr'
           ],
     en => [ 'Unknown recipient!',
             'The postbox of this acoount is full. You can not send a new messages.',
             'Please write a short subject of the message.',
             'The message does not contain any text.',
             'Internal error, the message was not saved.',
             'Your message is saved.',
             'Your message was NOT saved!<br>Please rename the attached file and try again.',
             'The postbox is not configured yet. You can not send a new message to this account.',
             'Session timeout, the message was NOT saved.',
             'Wrong data sent.',
             # 10
             'recipient',
             'mobile version',
             'subject',
             'desktop version',
             'message text',
             'attach a file',
             'max. 600kB',
             'send message',
             'PrivacyBox',
             'not encrypted',
             # 20
             'Will be encrypted with OpenPGP or S/MIME.',
             'The message will be saved without any information about the sender.<br>
              Please give a <strong>contact information</strong> in the message text for a response.',
             'The software recognices OpenPGP encrypted message text and encrypted files. If it was possible for you, please encrypt the message text and the attached file.',
             'It seems, you want to fake a HTML mail.',
             'The message contains bad HTML tags.',
             'Not encrypted for this recipient.',
             'Description',
             'Sign Up',
             'Login',
             'Contact',
             # 30
             'Tor web proxy',
             'more'
           ],

      fr => [ 'recepien inconnu!',
              'La messagerie est plain. Vous pouvez pas enovoyer des nouvels messages.',
              'Vieullez &eacute;crire un subjet pour le message.',
              'Le message ne contien pas du text.',
              'Erreur intern, le message n&apos;a pas &eacute;t&eacute; sauvegarder.',
              'Votre message es sauvegarder.',
              'Le message n&apos;a pas &eacute;t&eacute; sauvegarder!<br>Vieullez renommer la pi&egrave;ce et essayer a nouveau.',
              'La messagerie n&apos;a pas &eacute;t&eacute; configurer actuellement. Vous pouvez pas envoyer des nouvels messages &aacute; cette messagerie.',
              'La s&eacute;ance a &eacute;te cl&ocirc;turer, le message n&apos;est pas sauvegarder.',
              'Des faux dates envoyer.',
              'd&eacute;stinataire',
              'version mobile',
              'subjet',
              'version bureau',
              'texte message',
              'ajout&eacute; une pi&egrave;ce',
              'max. 600kB',
              'envoyer message',
              'PrivacyBox',
              'non crypt&eacute;',
              'Vas &eacute;tre envoyer par OpenPGP ou S/MIME.',
              'La message vas &eacute;tre sauvegarder sans information &aacute; propos de l&apos;envoyeur.<br>Laissez s&apos;il vous pla&icirc;t un <strong>contact d&apos;information</strong> pour une reponse.',
              'Le logiciel reconna&icirc;t les messages et pi&egrave;ce attaché crypt&eacute; par OpenPGP. Si c&apos;est possible pour vous, crypt&eacute; vos messages et pi&egrave;ce attach&eacute; vous m&ecirc;me.',
              'Il para&icirc;t que vous vouliez manipul&eacute; une message HTML.',
              'Ce message contient du faux code HTML.',
              'Non crypt&eacute; pour ce receveur.',
              'Description du service',
              'Inscription',
              'Connexion',
              'Contact',
              'proxy web TOR',
              'poursuit'
          ]
    );

$CGI::POST_MAX= $attachement_max_size * 1024;

# read the PBox main config file /etc/privacybox.conf, if exist
if (-e '/etc/privacybox.conf') {
	open (FILE, '/etc/privacybox.conf');
	my $line=0;
	while (<FILE>) {
		$line++;
		chomp;
		s/#.*//;
		s/^\s*//;
		s/\s*$//;
		next unless $_;

		my ($key, $value) = split(/\s+/, $_, 2);
		$key = lc($key);

		if($key eq 'pbox_main_dir') { $maindir= $value; }
	}
}

# Set the sub directories of the privacybox
if(!($maindir =~ /\/$/)) { $maindir= $maindir . '/'; }
my $main_dir= $maindir . 'cgi-data/';
my $mail_dir= $maindir . 'mail/';
my $tmp_mail_dir= $maindir . 'shiftmail/';
my $attachement_dir= $maindir . 'tmp/';
my $cgi_conf= $maindir . 'cgi-conf/pbox.conf';

# define the params
my $gpg_encryptd_host= 'localhost';
my $gpg_encryptd_port= 3025;
my $form_encryption_passwd= undef;
my $from_address= undef;
my $from_name= undef;
my $reply_address= undef;
my $reply_name = undef;
my $self_host= undef;
my $onion_host= undef;
my $i2p_host= undef;
my $i2p_user= undef;
my $i2p_pass= undef;

# read the params from config file
open (FILE, $cgi_conf);
my $line=0;
while (<FILE>) {
	$line++;
	chomp;
	s/#.*//;
	s/^\s*//;
	s/\s*$//;
	next unless $_;
	my ($key, $value) = split(/\s+/, $_, 2);
	$key = lc($key);
	next unless defined $value;

	if ($key eq 'gpg_encryptd_host') {
		$gpg_encryptd_host = $value;
	} elsif ($key eq 'gpg_encryptd_host' ) {
		$gpg_encryptd_port = $value;
	} elsif ($key eq 'user_conf_encrypt_pass' ) {
		$form_encryption_passwd = $value;
	} elsif ($key eq 'pbox_from_address' ) {
		$from_address = $value;
	} elsif ($key eq 'pbox_from_name' ) {
		$from_name = $value;
	} elsif ($key eq 'pbox_reply_to_address' ) {
		$reply_address = $value;
	} elsif ($key eq 'pbox_reply_to_name' ) {
		$reply_name = $value;
	} elsif ($key eq 'host_name' ) {
		$self_host = $value;
	} elsif ($key eq 'onion_name' ) {
		$onion_host = $value;
	} elsif ($key eq 'i2p_name' ) {
		$i2p_host = $value;
	} elsif ($key eq 'i2p_user' ) {
		$i2p_user = $value;
	} elsif ($key eq 'i2p_pass' ) {
		$i2p_pass = $value;
	}
}


# the hostname of the server and URL of the script
my $hostname= $ENV{'HTTP_HOST'};
if ( $hostname=~ /\.onion$/ ) { $hostname= 'http://' . $hostname; }
elsif ( $hostname=~ /\.i2p$/ ) { $hostname= 'http://' . $hostname; }
else { $hostname= 'https://' . $hostname; }
my $self= $hostname . $ENV{'SCRIPT_NAME'};

my $jap= 0;
my $addr= $ENV{REMOTE_ADDR};
if (($addr eq '80.237.152.53')||($addr eq '141.76.45.35')||($addr eq '141.76.45.34')||($addr eq '212.227.103.74')||
 ($addr eq '87.118.100.175')||($addr eq '80.237.191.141')||($addr eq '80.237.191.139')||($addr eq '87.230.56.32')||
 ($addr eq '64.202.107.25')||($addr eq '193.164.133.197')||($addr eq '80.190.200.171')||($addr eq '87.230.56.74')||
 ($addr eq '195.2.228.226')) { $jap= 1;}

# for session ID and user config
my $cfo = new CGI::EncryptForm(secret_key => $form_encryption_passwd);


my $stylesheet= '/pbox.css';

my $subj= '';
my $text= '';

my $write_form= 1;
my $error= 0;
my $err_msg= undef;
my $info_msg= undef;

# recipient configuration
my $forward;
my $email;
my $pgp_id;
my $i2p_reci;
my $encryption;


# bevorzugte Sprache ermitteln
my $lang= $query->param('lang');
if ((!(defined($lang)))  || ($lang eq "") || (!defined($messages{$lang}[0]))) { 
	my $tmplang= $ENV{'HTTP_ACCEPT_LANGUAGE'};
	if(defined($tmplang)) {
		if($tmplang =~ /^de/) { $lang= 'de'; }
		elsif($tmplang =~ /^fr/) { $lang= 'fr'; }
		else { $lang= 'en'; }
	} else { $lang= 'de'; }
}

# CGI-Parameter holen
my $reci= $query->param('sus');
my $mobi= $query->param('mobi');
if((defined($mobi)) && ($mobi eq '1')) { $stylesheet= '/mobi/mbox.css'; }

# Recipient überprüfen
if((defined($reci)) && ($reci =~ /^[a-z]+$/)) {
	# neues Formular schreiben
	my $config= $main_dir . $reci . '/user.cfg';
	if(!(-r $config)) {
		$reci= undef;
		$write_form= 0;
		$err_msg= $messages{$lang}[0];
		sleep 6;
	} else {
		# check, if more than max messages
		opendir MDIR, $mail_dir . $reci . '/Maildir/new';
		my @all_messages= readdir MDIR;
		close MDIR;
		if (@all_messages > 299) { 
			$write_form= 0;
			$err_msg= $messages{$lang}[1];
		}
		# check the user config
		open(CFG, $config);
		my $user_configuration= <CFG>;
		chomp $user_configuration;
		close CFG;
		my $newhashref = $cfo->decrypt($user_configuration);

		$forward= $newhashref->{'fwd'};
		$email= $newhashref->{'email'};
		$encryption= $newhashref->{'encr'};

		if (($forward eq '2') && ($email eq '')) { 
			$reci= undef;
			$write_form= 0;
			$err_msg= $messages{$lang}[7];
		}
	}
} else {
	# Formular Input verarbeiten
	my $session= $query->param('se');
	$subj= $query->param('betreff');
	$text= $query->param('artikel');
	if((defined($session)) && (defined($subj)) && (defined($text))) {
		# check session ID
		my $sessionhashref = $cfo->decrypt($session);
		$reci= $sessionhashref->{'sus'};
		my $config;
		my $reci_dir;
		if ((defined($reci)) && ($reci =~ /^[a-z]+$/)) { 
			$reci_dir= $main_dir . $reci;
			$config = $reci_dir . '/user.cfg'; 
		}
		if ((defined($reci)) && (defined($config)) && (-f $config)) {
			# check, if more than max messages
			opendir MDIR, $mail_dir . $reci . '/Maildir/new';
			my @all_messages= readdir MDIR;
			close MDIR;
			if (@all_messages > 399) { 
				$write_form= 0;
				$err_msg= $messages{$lang}[1];
			} else {

				# Daten prüfen
				if (($subj eq '') || ($text eq '')) {
					$write_form= 1;
					if ($subj eq "") { $err_msg= $messages{$lang}[2]; }
					if ($text eq "") { $err_msg= $messages{$lang}[3]; }
				} else {
					# Subject entschaerfen
					my $leer= ' ';
					$subj =~ s/\s/$leer/gs;

					# Text auf HTML-Fakes pruefen
					my $lotext= lc($text);
					if( ($lotext =~ /<\W*html\W*>/) && ($lotext =~ /<\W*body\W*>/) && 
						($lotext =~ /<\W*\/body\W*>/) && ($lotext =~ /<\W*\/html\W*>/)) {
						$write_form= 1;
						$err_msg= $messages{$lang}[23];
					} else {
						if( ($lotext =~ /<\W*img\W+src/) || ($lotext =~ /<\W*script\W/) ) {
							$write_form= 1;
							$err_msg= $messages{$lang}[24];
						} else {

							# User-Konfiguration einlesen
							open(CFG, $config);
							my $user_configuration= <CFG>;
							chomp $user_configuration;
							close CFG;
							my $newhashref = $cfo->decrypt($user_configuration);

							$forward= $newhashref->{'fwd'};
							$email= $newhashref->{'email'};
							$pgp_id= $newhashref->{'pgp'};
							$i2p_reci= $newhashref->{'i2p'};
							$encryption= $newhashref->{'encr'};

							my $to= $reci . '@encr.de';
							my $filename = $query->param('andatei');

							# senden einer Nachricht mit Anhang
							if((defined($filename)) && ($filename ne "")) {
								# check for User-Agent
								my $useragent= $ENV{'HTTP_USER_AGENT'};
								if (!(defined($useragent))) {
									$useragent= 'Mozilla/5.0 (compatible; Konqueror/3.5) KHTML/3.5.10 (like Gecko)';
								}
								# check Filename and create a temporary directory
								my $fname = FileUpload::Filename->name( { filename => $filename, agent => $useragent} );
								my $random_dir= int(rand 120000);
								my $anhang_dir= $attachement_dir . $random_dir;
								while ( mkdir($anhang_dir, 0700) == 0 ) {
									$random_dir= int(rand 120000);
									$anhang_dir= $attachement_dir . $random_dir;
								}
								my $anhangfile= $anhang_dir . '/' . $fname;
								my $anhang= $query->upload('andatei');

								open DAT,'>'.$anhangfile;
								binmode $anhang;
								binmode DAT;
								while(<$anhang>) { print DAT; }
								close DAT;

								if ($forward eq '3') {
									# senden an I2P
									if($encryption eq '1') {
										# OpenPGP-Verschlüsselung
										if (!(($text =~ /^\-\-\-\-\-BEGIN PGP MESSAGE\-\-\-/) && 
											($text =~ /\-\-\-\-\-END PGP MESSAGE\-\-\-\-\-\W*$/ ))) {
											# Verschlüsseln des Text
											my $gnupg= GnuPG::Interface->new();
											$gnupg->options->hash_init( 
												armor   => 1, 
												homedir => $reci_dir, 
												always_trust => 1,
												extra_args => '--no-emit-version',
											);
											$gnupg->options->push_recipients( $pgp_id ); 
											$gnupg->options->meta_interactive( 0 );

											my $rein= IO::Handle->new();
											my $raus= IO::Handle->new();
											my $rerr= IO::Handle->new();
											my $rr= GnuPG::Handles->new(stdin => $rein, stdout => $raus, stderr => $rerr );

											my $gpg_pid= $gnupg->encrypt( handles => $rr );
											setUTF8($text);
											print $rein $text;
											close $rein;
											$text= '';
											my @errortext;
											if(defined($rerr)) { @errortext= <$rerr>; }
											my $cipherline;
											if(defined($raus)) {
												while ($cipherline= <$raus>) { $text= $text . $cipherline; }
											}
											close $raus;
											close $rerr;
											waitpid $gpg_pid, 0;
											if ( @errortext > 0) {
												$error= 4;
												$err_msg= $messages{$lang}[4];
											}
										}
										if($error == 0) {
											open(DAT, $anhangfile);
											my $aline= <DAT>;
											close DAT; 
											if(!($aline =~ /^\-\-\-\-\-BEGIN PGP MESSAGE\-\-\-/)) {
												# Verschlüsseln des Anhang
												my $gpgdatei= $anhangfile . '.pgp';

												system("gpg --homedir $reci_dir --encrypt --armor --no-emit-version --no-comment --trust-model always --recipient $pgp_id -o $gpgdatei $anhangfile");

												system("shred -n 1 -u $anhangfile");
												$anhangfile= $gpgdatei;
											}
										}
									}
									if($error == 0) {
										# Senden an I2P-Account
										setUTF8($text);
										my $mail = new Mail::SendEasy( 
												smtp => 'localhost' , 
												port => '7659', 
												user => $i2p_user, 
												pass => $i2p_pass,
												timeout => 250 
										);
										my $status = $mail->send(
											from    => $i2p_user . '@mail.i2p' ,
											from_title => $from_name ,
											to      => $i2p_reci . '@mail.i2p' ,
											subject => $subj ,
											msg     => $text,
											anex    => $anhangfile
										) ;
										if (!$status) { 
											$err_msg= $messages{$lang}[4]; 
											$write_form= 0;
										} else { 
											$info_msg= $messages{$lang}[5] . ' (' . $messages{$lang}[10] . ': <strong>' . $reci . '</strong>)';
											$write_form= 0;
										}
									}
								} else {
									# senden (NICHT an I2P)
									if($encryption eq '1') {
										# OpenPGP-verschlüsselt
										if (($text =~ /^\-\-\-\-\-BEGIN PGP MESSAGE\-\-\-/) && ($text =~ /\-\-\-\-\-END PGP MESSAGE\-\-\-\-\-\W*$/ )) {
											# Prüfen des Anhangs
											open(DAT, $anhangfile);
											my $aline= <DAT>;
											close DAT; 
											if(!($aline =~ /^\-\-\-\-\-BEGIN PGP MESSAGE\-\-\-/)) {
												# Verschlüsseln des Anhangs
												my $gpgdatei= $anhangfile . '.pgp';

												system("gpg --homedir $reci_dir --encrypt --armor --no-emit-version --no-comment --trust-model always --recipient $pgp_id -o $gpgdatei $anhangfile");

												system("shred -n 1 -u $anhangfile");
												$anhangfile= $gpgdatei;
											}
											# Zusammenbauen der Mail
											my $mail = Mail::Builder->new();
											$mail->from($from_address, $from_name);
											if ($forward eq '1') { $mail->to->add( $reci . '@' . $self_host ); }
											else { $mail->to->add( $email ); }
											$mail->subject($subj);
											$mail->plaintext($text);
											$mail->attachment->add($anhangfile);
											my $message= $mail->stringify;

											# save message local
											my $messagedir= $mail_dir . $reci . '/Maildir/new/';
											if ($forward eq '2') { $messagedir= $tmp_mail_dir; }
											if(save_message_file(\$message, $messagedir) == 0) {
												$error= 4;
												$err_msg= $messages{$lang}[4];
											}
										} else {
											# OpenPGP-Verschlüsselung mit dem pbox-encryptd
											my $mail = Mail::Builder->new();
											$mail->from($from_address, $from_name);
											$mail->to->add($reci . '@' . $self_host);
											$mail->subject($subj);
											$mail->plaintext($text);
											$mail->attachment->add($anhangfile);
											my $mailer = Email::Send->new({mailer => 'SMTP'});
											$mailer->mailer_args([Host => $gpg_encryptd_host . ':' . $gpg_encryptd_port, ssl => 0]);
											$mailer->send($mail->stringify);
										}
									} else {
										# S/MIME oder keine Verschlüsselung
										my $mail = Mail::Builder->new();
										$mail->from($from_address, $from_name);
										if ($forward eq '1') { $mail->to->add( $reci . '@'. $self_host); }
										else { $mail->to->add( $email ); }
										$mail->subject($subj);
										$mail->plaintext($text);
										$mail->attachment->add($anhangfile);
										my $message= undef;

										if ($encryption eq '2') {
											# S/MIME encryption
											my $smime_file= $main_dir . $reci . '/smime.pem';
											if (!(-r $smime_file)) {
												$error= 4;
												$err_msg= $messages{$lang}[7];
											} else {
												my $smime_cert;
												open(CERT, $smime_file);
												while(<CERT>) { $smime_cert= $smime_cert . $_; }
												close CERT;
												my $message_unencr= $mail->stringify;
												my $smime = Crypt::SMIME->new();
												$smime->setPublicKey($smime_cert);
												$message= $smime->encrypt($message_unencr);
											}
										} else {
											$message= $mail->stringify;
										}
										# save message
										my $messagedir= $mail_dir . $reci . '/Maildir/new/';
										if ($forward eq '2') { $messagedir= $tmp_mail_dir; }
										if(save_message_file(\$message, $messagedir) == 0) {
											$error= 4;
											$err_msg= $messages{$lang}[4];
										}
									}
									$info_msg= $messages{$lang}[5] . ' (' . $messages{$lang}[10] . ': <strong>' . $reci . '</strong>)';
									$write_form= 0;
								}
								system("shred -n 1 -u $anhangfile");
								rmdir $anhang_dir;

							} else {
								# Senden der Nachricht ohne Anhang
								$write_form= 0;

								if(($text =~ /^\-\-\-\-\-BEGIN PGP MESSAGE\-\-\-/) && ($text =~ /\-\-\-\-\-END PGP MESSAGE\-\-\-\-\-\W*$/ )) {
									$encryption= 0;
								}

								if (($forward eq '2') && ($email eq '')) { 
									$error= 1; 
									$err_msg= $messages{$lang}[7];
								}

								my $message= 'From: '. $from_name .  ' <' . $from_address . '>' . "\n";
								if ($forward ne '3') {
									$message= $message . "User-Agent: PrivacyBox 1.1\nMIME-Version: 1.0\n";
									$message= $message . "Content-Type: text/plain; charset=UTF-8\nContent-Transfer-Encoding: 8bit\n";
									$message= $message . "Subject: $subj \n";
									if ($forward eq '2') {
										# send to an external email account (Date/Time kommt später)
										$message= $message . "To: $email\n"; 
										$message= $message . 'Reply-To: ' . $reply_name .  ' <' . $reply_address . '>' . "\n\n";
									} else { 
										# save local
										my $datum= time2str("%a, %e %b %Y %T %z", time() );
										$message= $message . "Date: $datum\n";
										$message= $message . "To: $reci" . '@' . $self_host . "\n"; 
										$message= $message . 'Reply-To: ' . $reply_name .  ' <' . $reply_address . '>' . "\n\n";
									}
								}

								if (($encryption eq '1') && ($error == 0)) {
									# openpgp encryption
									my $gnupg= GnuPG::Interface->new();
									$gnupg->options->hash_init( 
										armor   => 1, 
										homedir => $reci_dir, 
										always_trust => 1,
										extra_args => '--no-emit-version',
									);
									$gnupg->options->push_recipients( $pgp_id ); 
									$gnupg->options->meta_interactive( 0 );

									my $rein= IO::Handle->new();
									my $raus= IO::Handle->new();
									my $rerr= IO::Handle->new();
									my $rr= GnuPG::Handles->new(stdin => $rein, stdout => $raus, stderr => $rerr );

									my $gpg_pid= $gnupg->encrypt( handles => $rr );
									if ($forward eq "3") { setUTF8($text); }
									print $rein $text;
									close $rein;
									$text= '';
									my @errortext;
									my $cipherline;
									if($rerr) { @errortext= <$rerr>; }
									if(defined($raus)) {
										while ($cipherline= <$raus>) { 
											$message= $message . $cipherline; 
											$text= $text . $cipherline;
										}
									}
									close $raus;
									close $rerr;
									waitpid $gpg_pid, 0;
									if ( @errortext > 0) {
										$error= 4;
										$err_msg= $messages{$lang}[4];
									}

								} elsif (($encryption eq '2') && ($error == 0)) {
									# S/MIME encryption
									my $smime_file= $main_dir . $reci . '/smime.pem';
									if (!(-r $smime_file)) {
										$error= 4;
										$err_msg= $messages{$lang}[7];
									} else {		
										my $smime_cert;
										open(CERT, $smime_file);
										while(<CERT>) { $smime_cert= $smime_cert . $_; }
										close CERT;
										my $message_unencr= $message . $text;
										my $smime = Crypt::SMIME->new();
										$smime->setPublicKey($smime_cert);
										$message= $smime->encrypt($message_unencr);
									}
								} else {
									# no encryption, send simple text mail
									if ($forward ne '3') { $message= $message . $text; }
								}
								if ($error == 0) {
									# Senden der Mail
									if ($forward ne '3') {
										# save message
										my $messagedir= $mail_dir . $reci . '/Maildir/new/';
										if ($forward eq '2') { $messagedir= $tmp_mail_dir; }
										if(save_message_file(\$message, $messagedir) == 0) {
											$error= 4;
											$err_msg= $messages{$lang}[4];
										}
									} else {
										# send message to an ip2 mail account
										setUTF8($text);
										my $mail = new Mail::SendEasy( 
											smtp => 'localhost' , 
											port => '7659', 
											user => $i2p_user, 
											pass => $i2p_pass,
											timeout => 250 
										);
										my $status = $mail->send(
											from    => $i2p_user . '@mail.i2p' ,
											from_title => $from_name ,
											to      => $i2p_reci . '@mail.i2p' ,
											subject => $subj ,
											msg     => $text
										) ;
										if (!$status) { 
											$err_msg= $messages{$lang}[4]; 
											$error= 4;
										} 
									}

								}
								if ($error == 0) { $info_msg= $messages{$lang}[5] . ' (' . $messages{$lang}[10] . ': <strong>' . $reci . '</strong>)'; }
							}
						}
					}
				}	
			}
		} else {
			# session timeout
			$err_msg= $messages{$lang}[8];
			$write_form= 0;
		}
	} else {
		$err_msg= $messages{$lang}[9];
		$write_form= 0;
	}
}


# HTML-Kopf schreiben
print "Content-type: text/html\n\n";
print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"><html>';
print '<head><title>PrivacyBox';
if(defined($reci)) { print ' (', $reci, ')'; }
print '</title>  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">';
print '<meta http-equiv="expires" content="0">';
print '<meta NAME="robots" content="noindex,nofollow"><meta http-equiv="Content-Style-Type" content="text/css">';
print '<LINK rel="StyleSheet" type="text/css" href="',  $stylesheet, '">';
print '</head><body>';

if((defined($mobi)) && ($mobi eq '1')) {
	# Mobil-Version
	if(defined($reci)) { 
		print '<div class="head">', $messages{$lang}[10] , ': ' , $reci;
		if($write_form == 1) {
			# Auswahl der Sprache für das Formular
			print '<a href="', $self, '?sus=', $reci, '&amp;lang=en&amp;mobi=1">';
			print '<img src="/images/en.png" hspace="10" vspace="0" alt="english" width="24" height="16" border="0"></a>';
			print '<a href="', $self, '?sus=', $reci, '&amp;lang=de&amp;mobi=1">';
			print '<img src="/images/de.png" hspace="5" vspace="0" alt="deutsch" width="24" height="16" border="0"></a>';
			print '<a href="', $self, '?sus=', $reci, '&amp;lang=fr&amp;mobi=1">';
			print '<img src="/images/fr.png" hspace="5" vspace="0" alt="fran&ccedil;ais" width="24" height="16" border="0"></a>';
		}
		print '</div>'; 
		print '<p><a href="', $self, '?sus=', $reci, '&amp;lang=', $lang, '">', $messages{$lang}[13], '</a></p>';
	} else { print '<div class="head">PrivacyBox</div><p>';}

} else {
	# Desktop-Version
	print '<div id="all"><div id="head">';
	print '<h1>', $messages{$lang}[18], '</h1></div>'; 

	if($write_form == 1) {
		# Auswahl der Sprache für das Formular
		print '<div id="language_selection">';
		print '<a href="', $self, '?sus=', $reci, '&amp;lang=en">';
		print '<img src="/images/en.png" hspace="5" vspace="0" alt="english" width="24" height="16" border="0"></a>', "\n";
		print '<a href="', $self, '?sus=', $reci, '&amp;lang=de">';
		print '<img src="/images/de.png" hspace="5" vspace="0" alt="deutsch" width="24" height="16" border="0"></a>', "\n";
		print '<a href="', $self, '?sus=', $reci, '&amp;lang=fr">';
		print '<img src="/images/fr.png" hspace="5" vspace="0" alt="fran&ccedil;ais" width="24" height="16" border="0"></a>';
		print '</div>';
	}

	if ((defined($reci)) && ($write_form == 1)) { 
		print '<div id="anonymous_use">';
		if($lang eq 'de') {
			# Der deutsche Hinweis auf die Hidden Services
			print 'Sie können die Kontaktseite anonym und unbeobachtet mit '; 
			if ($jap == 1) { print '<span class="anonymous_active">JonDonym</span>'; }
			else { print '<a href="https://www.jondos.de/de/" class="anonymous_use_link">JonDonym</a>'; }
			print ' nutzen.<br> Die Kontaktseite ist auch als ';
			if ($hostname=~ /\.onion$/ ) { print '<span class="anonymous_active">Tor&nbsp;Hidden&nbsp;Service</span>'; } 
      else { print '<a href="http://', $onion_host, '/cgi-bin/tram_msg.pl?sus=', $reci, '&amp;lang=de" class="anonymous_use_link">Tor&nbsp;Hidden&nbsp;Service</a>'; }
			print ' und ';
			if ($hostname=~ /\.i2p$/ ) { print '<span class="anonymous_active">I2P&nbsp;eepsite</span>'; } 
			else { print '<a href="http://', $i2p_host, '/cgi-bin/tram_msg.pl?sus=', $reci, '&amp;lang=de" class="anonymous_use_link">I2P&nbsp;eepsite</a>'; }
			print ' erreichbar.';

		} elsif ($lang eq 'fr') {
			# Der Hinweis auf die Hidden Services in Französisch
			print 'Nous vous conseillons d&apos;utiliser ce service, anonyme et intra&ccedil;able, par ';
			if ($jap == 1) { print '<span class="anonymous_active">JonDonym</span>'; }
      else { print '<a href="https://www.jondos.de/en/" class="anonymous_use_link">JonDonym</a>'; }
			print ', par ';
			if ($hostname=~ /\.onion$/ ) { 
				print '<span class="anonymous_active">l&apos;interm&eacute;diaire&nbsp;du&nbsp;service&nbsp;TOR</span>';
			} else {
				print '<a href="http://', $onion_host, '/cgi-bin/tram_msg.pl?sus=', $reci, '&amp;lang=fr" class="anonymous_use_link">l&apos;interm&eacute;diaire&nbsp;duvservice&nbsp;TOR</a>';
			}
			print ' en ';
			if ($hostname=~ /\.i2p$/ ) { 
				print '<span class="anonymous_active">tant&nbsp;que&nbsp;site&nbsp;I2P</span>';
			} else {
				print '<a href="http://', $i2p_host, '/cgi-bin/tram_msg.pl?sus=', $reci, '&amp;lang=fr" class="anonymous_use_link">tant&nbsp;que&nbsp;site&nbsp;I2P</a>';
			}
			print ' ou avec un <a href="https://www.awxcnx.de/cgi-bin/proxy4/nph-proxy.cgi/000000A/http/privacybox.i2p/cgi-bin/tram_msg.pl?sus=', $reci;
			print '&amp;lang=fr" class="anonymous_use_link">proxy&nbsp;web&nbsp;I2P</a>.';

		} else {
			# Der englische Hinweis auf die Hidden Services
			print 'You may use this contact page anonymous and not traceable by ';
			if ($jap == 1) { print '<span class="anonymous_active">JonDonym</span>'; }
			else {  print ' <a href="https://www.jondos.de/en/" class="anonymous_use_link">JonDonym</a>'; }
			print '.<br>';
			print 'This contact page ist accessible by ';
			if ($hostname=~ /\.onion$/ ) { 
				print '<span class="anonymous_active">Tor&nbsp;hidden&nbsp;service</span>';
			} else {
				print '<a href="http://', $onion_host. '/cgi-bin/tram_msg.pl?sus=', $reci, '&amp;lang=en" class="anonymous_use_link">Tor&nbsp;hidden&nbsp;service</a>';
			}
			print ' or ';
			if ($hostname=~ /\.i2p$/ ) { 
				print '<span class="anonymous_active">I2P&nbsp;eepsite</span>';
			} else {
				print '<a href="http://', $i2p_host, '/cgi-bin/tram_msg.pl?sus=', $reci, '&amp;lang=en" class="anonymous_use_link">I2P&nbsp;eepsite</a>';
			}
			print ' too.';
		}
		print '</div>';
	}
 
	print '<div id="wirspeichernnichtlogo"><a href="http://www.wirspeichernnicht.de/content/view/10/22/">';
	print '<IMG src="/images/wirspeichernnichtsiegel_d.png" width="109" height="113" border="0"></a></div>';

	# navigation toolbar
	print '<div id="navigation"><div id="navigation_pbox">';
	print '<a href="/index.', $lang , '.html" class="navigation_pbox_link">', $messages{$lang}[26], '</a> &nbsp; ';
	print '<a href="/cgi-bin/tram_neu.pl?lang=', $lang ,'&amp;ac=0" class="navigation_pbox_link">', $messages{$lang}[27], '</a> &nbsp; ';
	print '<a href="/cgi-bin/tram_login.pl?ac=0&amp;lang=', $lang ,'" class="navigation_pbox_link">', $messages{$lang}[28], '</a> &nbsp; '; 
	if((defined($reci)) && ($reci eq 'admin')) { 
		print '<span class="navigation_pbox_active">', $messages{$lang}[29], '</span>'; 
	} else { 
		print '<a href="/cgi-bin/tram_msg.pl?sus=admin&amp;lang=', $lang ,'" class="navigation_pbox_link">', $messages{$lang}[29], '</a>'; 
	}
	print '</div><div id="navigation_webservices">';
	print '<a href="/tor-proxy.', $lang ,'.html" class="navigation_webservices_link">', $messages{$lang}[30], '</a> &nbsp; ';
	print '<a href="/tor-proxy.', $lang ,'.html" class="navigation_webservices_link">', $messages{$lang}[31], '&nbsp;&raquo;</a>';
	print '</div></div><div id="content">';
}

if(defined($err_msg)) { print '<div class="error">', $err_msg, '</div>'; }
if(defined($info_msg)) { print '<div class="info">', $info_msg, '</div>'; }


if($write_form == 1) {
	# Formular schreiben
	my $hashref = { sus => $reci };
	my $session= $cfo->encrypt($hashref);
        print "\n\n";
	print '<form action="', $self ,'" method="POST" target="_self" ENCTYPE="multipart/form-data">', "\n";
	print '<INPUT type="hidden" name="se" value="', $session, '">', "\n";
	print '<INPUT type="hidden" name="lang" value="', $lang, '">', "\n";

	if((defined($mobi)) && ($mobi eq '1')) {
		# Mobil-Version
		print '<INPUT type="hidden" name="mobi" value="1">';
		print $messages{$lang}[12], ':<br><input type="text" name="betreff" tabindex="1" value="', $subj, '"><br>';
		print $messages{$lang}[14], ':<br><textarea rows="5" cols="35" name="artikel" tabindex="2">', $text, '</textarea><br>';
		print $messages{$lang}[15], ' (', $messages{$lang}[16], '):<br>';
		print '<input type="file" name="andatei" accept="*/*" maxlength="656600" tabindex="3"><br>';
		print '<input type="submit" VALUE="', $messages{$lang}[17], '"  tabindex="4"></form>';
	} else {
		# Desktop-Version
		print '<div align="center">', "\n", '<table>', "\n";
		print '<tr><td align="right">', $messages{$lang}[10], ':</td>', "\n", '<td  align="left"> <strong>', $reci, '</strong></td></tr>', "\n";
		print '<tr><td align="right">', $messages{$lang}[12], ':<br><br><br></td>', "\n";
		print '<td align="left"><input type="text" name="betreff" tabindex="1" size="35%" value="', $subj, '"><br>', "\n";
		print '<span style="font-size:12px;">(', $messages{$lang}[19], ')</span><br><br></td></tr>', "\n";
		print '<tr><td colspan="2">',$messages{$lang}[14], ': <span style="font-size:12px;">(';
		if($encryption eq '0') { print $messages{$lang}[25]; }
		else { print $messages{$lang}[20]; }
		print ')</span> <br>', "\n";
		print '<textarea rows="10" cols="70" name="artikel" tabindex="2">';
                if (defined($text)) { print $text; } 
                print '</textarea><br>', "\n";
		print $messages{$lang}[21], '<br><br>', "\n";
		print '</TD></TR><tr><TD align="right">', $messages{$lang}[15], ':<br>(', $messages{$lang}[16], ')&nbsp;&nbsp;<br><br></td>', "\n";
		print '<td align="left"><input type="file" name="andatei" accept="*/*" maxlength="656600" tabindex="3"><br>', "\n";
		print '<span style="font-size:12px;">(';
		if($encryption eq '0') { print $messages{$lang}[25]; }
		else { print $messages{$lang}[20]; }
		print ')</span></TD>', "\n";
		print '</tr></table><br>', "\n";
		print '<input type="submit" VALUE="', $messages{$lang}[17], '"  tabindex="4"><br><br></div>', "\n", '</form>', "\n\n";
		print '<strong>End-to-End-Encryption:</strong> ', $messages{$lang}[22]; 
		print '<br><br></div></div>';
	}
}
if((defined($mobi)) && ($mobi eq '1')) { print '</p>';}
print '</body></html>';


# save the mail in a directory
sub save_message_file {

	my ($savemail, $dir)= @_;
	my $random_msg= int(rand 120000);
	my $mailmsg= $dir . $random_msg . '@privacybox.de';
	while(-f $mailmsg) {
		$random_msg= int(rand 120000);
		$mailmsg= $dir . $random_msg . '@privacybox.de';
	}
	open(MSG, ">$mailmsg");
	if (MSG) {
		print MSG $$savemail;
		close MSG;
		return 1;
	} else { return 0; }
}
