#!/usr/bin/perl -w

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use CGI::EncryptForm;
use DBI;
use GnuPG::Interface;
use GnuPG::Handles;

use integer;

$query = new CGI;

# The default main directory
my $maindir= '/privacybox/';


my @buchstaben= ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z');

my $attachement_max_size= 60;

my $max_user_accounts= 5000;

# Message translations
my %messages = (
     de => [ 'Fehlerhafte Daten gesendet.',
             'Dieses Pseudonym ist bereits vergeben. Bitte w&#228;hlen Sie ein anderes Pseudonym.',
             'Zuviele Anmeldungen in den letzten 30min. Bitte wiederholen Sie Ihre Anmeldung in 20-30min.',
             'Die eingegebenen Passworte stimmen nicht &#252;berein.',
             'Das Pseudonym enth&#228;lt unzul&#228;ssige Zeichen.',
             'Timeout, bitte versuchen Sie es noch einmal.',
             'Die maximale Anzahl von Nutzern ist erreicht - sorry.',
             'Die Angabe einer Kontaktadresse ist <strong>freiwillig</strong>. Bitte beachten Sie, dass wir Ihnen bei einem vergessenen Passwort o.&#228; nur helfen können, wenn wir als Inhaber des Accounts verifizieren können. Wir können Sie anhand einer signierten Nachricht verifizieren (wenn Sie OpenPGP nutzen) oder anhand der Kontaktadresse.',
             'Wie können wir Sie ereichen? (Telefon, IM, E-Mail, I2P-Mail...)',
             'Die Kontaktadresse wird verschl&#252;sselt gespeichert. Nur die Administratoren<br>haben Zugriff auf diese Information, um Sie bei Verlust des Passwortes<br>als Inhaber des Accounts zu verifizieren und Ihnen zu helfen.',
             # 10
             'N&#228;chster Schritt',
             'Account-Daten',
             'Pseudonym',
             'nur Kleinbuchstaben a-z',
             'Passwort',
             'Das Passwort bitte 2x wiederholen.',
             'Account anlegen',
             'Ihre Kontaktseite wird erreichbar sein unter',
             'Ihr Account wurde angelegt.',
             'Bitte loggen Sie sich ein und konfigurieren Sie die Verschl&#252;sselung<br>und evtl. die Weiterleitung eingehender Nachrichten.',
             # 20
             'Bescheibung',
             'Anmelden',
             'Login',
             'Kontakt',
             'Tor-Web-Proxy',
             'mehr'
           ],

     en => [  'Wrong data sent.',
              'The pseudonym is already in use. Please choose a new pseudonym.',
              'To much new accounts in the last 30 minutes. Please try again later.',
              'The passwords does not match.',
              'The pseudonym contains wrong characters. Please use only a-z.',
              'Timeout, please try again.',
              'Max. number of user accounts is reached - sorry.',
              'It is <strong>not necessary</strong>, to give us a contact address. But (if your password was lost or something else) we can help you only, if we could verify identity of the the user of an account. We may verify your identity by an OpenPGP signed message (if you were using OpenPGP) or by your contact address.',
              'Your contact address (fon, instant messaging, e-mail, i2p-mail...)',
              'Your contact address will be saved encrypted. Only the admins of<br>the service may decrypt this information, if it was nessecary to help you.',
              #10
              'next step',
              'account data',
              'pseudonym',
              'use only small characters a-z',
              'password',
              'Please retype the password 2 times.',
              'create account',
              'Your contact page will be created at',
              'Your account is ready for use.',
              'Please, login and edit your settings for message encryption and forwarding.',
              # 20
              'Description',
              'Sign Up',
              'Login',
              'Contact',
              'Tor web proxy',
              'more'
           ],

      fr => [ 'Des faux dates envoyer.',
              'Le pseudonym est d&eacute;ja reserv&eacute;. Choisissez s&apos;il vous pla&icirc;t un autre pseudonym.',
              'Il y avait trop de nouveau box enregistr&eacute; les dernier 30 minutes. Essaier le s&apos;il vous pla&icirc;t plus tard.',
              'Votre passphrase n&apos;&eacute;tait pas correct.',
              'Le pseudonym contien des faux charact&egrave;res. Utilisez seulement a-z.',
              'Temps de d&eacute;bouclement, re-essayer le plus tard.',
              'Le maximum des boxes est arriv&eacute;. Desol&eacute;.',
              ' ',
              ' ',
              ' ',
              '&Eacute;tape suivante',
              'les dates de la boxe',
              'pseudonym',
              'utiliser seulement des charact&egrave;rs a-z',
              'mot de passe',
              'S&apos;il vous pla&icirc;t. Redonner votre mot de passe deux fois.',
              'cr&eacute;er la boxe.',
              'Votre page de contact va &ecirc;tre cr&eacute;er &eacute;',
              'Votre box est d&eacute;ja en utilisation.',
              'S&apos;il vous pla&icirc;t, connecter vous et editer votre param&egrave;tres pour l&apos;encryption et la redirection.',
              # 20
              'Description du service',
              'Inscription',
              'Connexion',
              'Contact',
              'proxy web TOR',
              'poursuit'
            ]
   );

# read the PBox main config file /etc/privacybox.conf, if exist
if (-e '/etc/privacybox.conf') {
	open (FILE, '/etc/privacybox.conf');
	my $line=0;
	while (<FILE>) {
		$line++;
		chomp;
		s/#.*//;
		s/^\s*//;
		s/\s*$//;
		next unless $_;

		my ($key, $value) = split(/\s+/, $_, 2);
		$key = lc($key);

		if($key eq 'pbox_main_dir') { $maindir= $value; }
	}
}

# Set the sub directories of the privacybox
if(!($maindir =~ /\/$/)) { $maindir= $maindir . '/'; }
my $main_dir= $maindir . 'cgi-data/';
my $mail_dir= $maindir . 'mail/';
my $admin_key_dir= $maindir . 'admin-keys';
my @admin_keys= undef;
my $cgi_conf= $maindir . 'cgi-conf/pbox.conf';

# define the params
my $form_encryption_passwd= undef;
my $mysql_user= undef;
my $mysql_passwd= undef;
my $self_host= undef;
my $onion_host= undef;
my $i2p_host= undef;

# read the params from config file
open (FILE, $cgi_conf);
my $line=0;
while (<FILE>) {
	$line++;
	chomp;
	s/#.*//;
	s/^\s*//;
	s/\s*$//;
	next unless $_;
	my ($key, $value) = split(/\s+/, $_, 2);
	$key = lc($key);
	next unless defined $value;

	if ($key eq 'host_name' ) {
		$self_host = $value;
	} elsif ($key eq 'onion_name' ) {
		$onion_host = $value;
	} elsif ($key eq 'i2p_name' ) {
		$i2p_host = $value;
	} elsif ($key eq 'user_conf_encrypt_pass' ) {
		$form_encryption_passwd = $value;
	} elsif ($key eq 'mysql_pass' ) {
		$mysql_passwd = $value;
	} elsif ($key eq 'mysql_user' ) {
		$mysql_user = $value;
	} elsif ($key eq 'admin_keys' ) {
		@admin_keys = split /,/, $value;
	}
   
}


# the hostname of the server and URL of the script
my $hostname= $ENV{'HTTP_HOST'};
if ( $hostname=~ /\.onion$/ ) { $hostname= 'http://' . $hostname; }
elsif ( $hostname=~ /\.i2p$/ ) { $hostname= 'http://' . $hostname; }
else { $hostname= 'https://' . $hostname; }
my $self= $hostname . $ENV{'SCRIPT_NAME'};

my $jap= 0;
my $addr= $ENV{REMOTE_ADDR};
if (($addr eq '80.237.152.53')||($addr eq '141.76.45.35')||($addr eq '141.76.45.34')||($addr eq '212.227.103.74')||
 ($addr eq '87.118.100.175')||($addr eq '80.237.191.141')||($addr eq '80.237.191.139')||($addr eq '87.230.56.32')||
 ($addr eq '64.202.107.25')||($addr eq '193.164.133.197')||($addr eq '80.190.200.171')||($addr eq '87.230.56.74')||
 ($addr eq '195.2.228.226')) { $jap= 1;}

# for session ID and user config
my $cfo = new CGI::EncryptForm(secret_key => $form_encryption_passwd);
my $session;

my $lang= $query->param('lang');
if ((!(defined($lang)))  || ($lang eq "") || (!defined($messages{$lang}[0]))) { 
	my $tmplang= $ENV{'HTTP_ACCEPT_LANGUAGE'};
	if(defined($tmplang)) {
		if($tmplang =~ /^de/) { $lang= 'de'; }
		elsif($tmplang =~ /^fr/) { $lang= 'fr'; }
		else { $lang= 'en'; }
	} else { $lang= 'de'; }
}

# Default ist Fehlermeldung
my $next_step= 0;

my $akt_step= $query->param('ac');
if((defined($akt_step)) && ($akt_step ne '0')) {
# check for max user
opendir MDIR, $main_dir;
my @all_users= grep !/^\./, readdir MDIR;
close MDIR;
if (@all_users < $max_user_accounts) {
	if(defined($akt_step)) {
		if($akt_step == 1) {
			my $erreichen= $query->param('erreichen');
			if (defined($erreichen)) {
				my $lts= time();
				if($erreichen ne '') {
					my $bhashref = { erre => $erreichen, lts => $lts };
					$session= $cfo->encrypt($bhashref);
				} else {
					my $bhashref = { lts => $lts };
					$session= $cfo->encrypt($bhashref);
				}
				$next_step= 11;
			} else { $err_msg= $messages{$lang}[0]; }
		} elsif ($akt_step == 2) {
			$session= $query->param('se');
			my $user= $query->param('pseudo');
			my $passwd1= $query->param('pw1');
			my $passwd2= $query->param('pw2');
			if((defined($session)) && (defined($user)) && (defined($passwd1)) && (defined($passwd2))) {
				my $dhashref= $cfo->decrypt($session);
				my $old_time= $dhashref->{'lts'};
				if((defined($old_time)) && (time() - $old_time > 5) && (time() - $old_time < 600)) {
					if(($user ne '') && ($user =~ /^[a-z]+$/ )) {
						if(($passwd1 ne '') && ($passwd2 ne '') && ($passwd1 eq $passwd2)) {

							my $newuserdir= $main_dir . $user;
							my $newmaildir= $mail_dir . $user;
							if(($user ne 'noreply') && (mkdir($newuserdir,0700)) && (mkdir($newmaildir))) {

								mkdir($newmaildir . '/Maildir',0700);
								mkdir($newmaildir . '/Maildir/new',0700);
								mkdir($newmaildir . '/Maildir/cur',0700);
								mkdir($newmaildir . '/Maildir/tmp',0700);
								# setzen der Defaultwerte
									my $ahashref = { 
										encr => 0,                     # Verschlüsselung 0: none, 1: pgp, 2: smime
										fwd => 2,                      # Weiterleitung            1: pop, 2: extern  3: mixmaster
										pgp => '',
										email => '' 
									};
									my $save= $cfo->encrypt($ahashref);
									my $userconfig= $newuserdir . '/user.cfg';
									open(OUTF, ">$userconfig");
									print OUTF $save, "\n";
									close OUTF;
									# Kontaktdaten speichern
									if(defined($dhashref->{'erre'})) {
										my $gnupg= GnuPG::Interface->new();
										$gnupg->options->hash_init( armor   => 1, homedir => $admin_key_dir, always_trust => 0);
										$gnupg->options->push_recipients( @admin_keys );
										$gnupg->options->meta_interactive(0);

										my $rein= IO::Handle->new();
										my $raus= IO::Handle->new();
										my $rerr= IO::Handle->new();
										my $rr= GnuPG::Handles->new(stdin => $rein, stdout => $raus, stderr => $rerr );

										my $gpg_pid= $gnupg->encrypt( handles => $rr );
										print $rein $dhashref->{'erre'}, "\n";
										close $rein;
										my @cipher;
										if(defined($raus)) { @cipher= <$raus>; }
										close $raus;
										close $rerr;
										waitpid $gpg_pid, 0;

										$userconfig= $newuserdir . '/contact.txt.asc';
										open(OUTF, ">$userconfig");
										print OUTF @cipher, "\n";
										close OUTF;
									}
									# Datenbank aktualisieren
									my $salt2= $buchstaben[int(rand @buchstaben)] . $buchstaben[int(rand @buchstaben)];
									my $passwd_crypt= crypt($passwd1,$salt2);
									my $mysql = DBI -> connect ("DBI:mysql:database=privacybox", $mysql_user , $mysql_passwd, {'RaiseError' => 1});
									my $usermail= $user . '/';
									my $statement = $mysql -> prepare ('INSERT INTO passwd VALUES (' . $mysql->quote($user) . ', ' . $mysql->quote($passwd_crypt) . ', 33, 33, ' . $mysql->quote($newmaildir) . ', ' . $mysql->quote('Maildir/') . ')');
									$statement -> execute ();
									$statement -> finish ();
									$mysql -> disconnect ();
									$next_step= 12;
								} else {
									$err_msg= $messages{$lang}[1];
									$next_step= 11;
								}

							} else { $next_step= 11; $err_msg= $messages{$lang}[3];}
						} else { $next_step= 11; $err_msg= $messages{$lang}[4];}
					} else { $next_step= 10; $err_msg= $messages{$lang}[5]; }
				} else { $err_msg= $messages{$lang}[0]; }
			} else { $err_msg= $messages{$lang}[0]; } 
		} else { $err_msg= $messages{$lang}[0]; }
	} else { $err_msg= $messages{$lang}[6]; }

} else {
   $next_step= 100;
}


# HTML-Kopf schreiben
print "Content-type: text/html\n\n";
print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"><html>';
print '<head><title>PrivacyBox</title>  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">';
print '<meta http-equiv="expires" content="0">';
print '<meta NAME="robots" content="noindex,nofollow"><meta http-equiv="Content-Style-Type" content="text/css">';
print '<LINK rel="StyleSheet" type="text/css" href="/pbox.css">';
print '</head><body><div id="all"><div id="head">';

print '<h1>PrivacyBox</h1></div>';

if($next_step == 100) {
	# Auswahl der Sprache
	print '<div id="language_selection">';
	print '<a href="/cgi-bin/tram_neu.pl?lang=en&amp;ac=0">';
	print '<img src="/images/en.png" hspace="5" vspace="0" alt="english" width="24" height="16" border="0"></a>', "\n";
	print '<a href="/cgi-bin/tram_neu.pl?lang=de&amp;ac=0">';
	print '<img src="/images/de.png" hspace="5" vspace="0" alt="deutsch" width="24" height="16" border="0"></a>', "\n";
	print '<a href="/cgi-bin/tram_neu.pl?lang=fr&amp;ac=0">';
	print '<img src="/images/fr.png" hspace="5" vspace="0" alt="fran&ccedil;ais" width="24" height="16" border="0"></a>';
	print '</div>';
}

print '<div id="anonymous_use">';
if($lang eq 'de') {
	# Der deutsche Hinweis auf die Hidden Services
	print 'Sie können die PrivacyBox anonym und unbeobachtet mit '; 
	if ($jap == 1) { print '<span class="anonymous_active">JonDonym</span>'; }
	else { print '<a href="https://www.jondos.de/de/" class="anonymous_use_link">JonDonym</a>'; }
	print ' nutzen.<br> Die PrivacyBox ist auch als ';
	if ($hostname=~ /\.onion$/ ) { 
		print '<span class="anonymous_active">Tor&nbsp;Hidden&nbsp;Service</span>';
	} else {
		print '<a href="http://', $onion_host, '/cgi-bin/tram_neu.pl?lang=de&amp;ac=0" class="anonymous_use_link">Tor&nbsp;Hidden&nbsp;Service</a>';
	}
	print ' und ';
	if ($hostname=~ /\.i2p$/ ) { 
		print '<span class="anonymous_active">I2Pveepsite</span>';
	} else {
		print '<a href="http://', $i2p_host, '/cgi-bin/tram_neu.pl?lang=de&amp;ac=0" class="anonymous_use_link">I2P&nbsp;eepsite</a>';
	}
	print ' erreichbar.';

} elsif ($lang eq 'fr') {
	# Der Hinweis auf die Hidden Services in Französisch
	print 'Nous vous conseillons d&apos;utiliser ce service, anonyme et intra&ccedil;able, par ';
	if ($jap == 1) { print '<span class="anonymous_active">JonDonym</span>'; }
	else { print '<a href="https://www.jondos.de/en/" class="anonymous_use_link">JonDonym</a>'; }
	print ',<br>par ';
	if ($hostname=~ /\.onion$/ ) { 
		print '<span class="anonymous_active">l&apos;interm&eacute;diaire&nbsp;du&nbsp;service&nbsp;TOR</span>';
	} else {
		print '<a href="http://', $onion_host, '/cgi-bin/tram_neu.pl?lang=fr&amp;ac=0" class="anonymous_use_link">l&apos;interm&eacute;diaire&nbsp;du&nbsp;service&nbsp;TOR</a>';
	}
	print ', en ';
	if ($hostname=~ /\.i2p$/ ) { 
		print '<span class="anonymous_active">tant&nbsp;que&nbsp;site&nbsp;I2P</span>';
	} else {
		print '<a href="http://', $i2p_host, '/cgi-bin/tram_neu.pl?lang=fr&amp;ac=0" class="anonymous_use_link">tant&nbsp;que&nbsp;site&nbsp;I2P</a>';
	}
	print ' ou avec un <a href="https://www.awxcnx.de/cgi-bin/proxy4/nph-proxy.cgi/000000A/http/privacybox.i2p/cgi-bin/tram_neu.pl?lang=fr&amp;ac=0" class="anonymous_use_link">proxy&nbsp;web&nbsp;I2P</a>.';

} else {
	# Der englische Hinweis auf die Hidden Services
	print 'You may use the PrivacyBox anonymous and not traceable by ';
	if ($jap == 1) { print '<span class="anonymous_active">JonDonym</span>'; }
	else { print ' <a href="https://www.jondos.de/en/" class="anonymous_use_link">JonDonym</a>'; }
	print '.<br>';
	print 'The PrivacyBox ist accessible by ';
	if ($hostname=~ /\.onion$/ ) { 
		print '<span class="anonymous_active">Tor&nbsp;hidden&nbsp;service</span>';
	} else {
		print '<a href="http://', $onion_host, '/cgi-bin/tram_neu.pl?lang=en&amp;ac=0" class="anonymous_use_link">Tor&nbsp;hidden&nbsp;service</a>';
	}
	print ' or ';
	if ($hostname=~ /\.i2p$/ ) { 
		print '<span style="color:#00af11;"class="anonymous_active">I2P&nbsp;eepsite</span>';
	} else {
		print '<a href="http://', $i2p_host, '/cgi-bin/tram_neu.pl?lang=en&amp;ac=0" class="anonymous_use_link">I2P&nbsp;eepsite</a>';
	}
	print ' too.';
}
print '</div>';


print '<div id="wirspeichernnichtlogo"><a href="http://www.wirspeichernnicht.de/content/view/10/22/">';
print '<IMG src="/images/wirspeichernnichtsiegel_d.png" width="109" height="113" border="0"></a></div>';


# navigation toolbar
print '<div id="navigation"><div id="navigation_pbox">';
print '<a href="/index.', $lang , '.html" class="navigation_pbox_link">', $messages{$lang}[20], '</a> &nbsp; ';
print '<span class="navigation_pbox_active">', $messages{$lang}[21], '</span> &nbsp; ';
print '<a href="/cgi-bin/tram_login.pl?ac=0&amp;lang=', $lang ,'" class="navigation_pbox_link">', $messages{$lang}[22], '</a> &nbsp; '; 
print '<a href="/cgi-bin/tram_msg.pl?sus=admin&amp;lang=', $lang ,'" class="navigation_pbox_link">', $messages{$lang}[23], '</a>';
print '</div><div id="navigation_webservices">';
print '<a href="/tor-proxy.', $lang ,'.html" class="navigation_webservices_link">', $messages{$lang}[24], '</a> &nbsp; ';
print '<a href="/tor-proxy.', $lang ,'.html" class="navigation_webservices_link">', $messages{$lang}[25], '&nbsp;&raquo;</a>';
print '</div></div><div id="content">';


if(defined($err_msg)) { print '<div class="error">', $err_msg, '</div>'; }
if(defined($info_msg)) { print '<div class="info">', $info_msg, '</div>'; }

if($next_step == 10) {
	print $messages{$lang}[7];
	print '<br><br><br><div align="center">';
	print '<form action="/cgi-bin/tram_neu.pl" method="POST" target="_self" ENCTYPE="multipart/form-data">';
	print '<input type="hidden" name="ac" value="1"><input type="hidden" name="lang" value="', $lang, '">';
	print $messages{$lang}[8];
	print '<br><input type="text" name="erreichen" tabindex="1" size="65%"><br><span style="font-size:12px;">';
	print '</span><br><br><input type="submit" VALUE="',$messages{$lang}[10],' -&#187;" tabindex="2"></form>';
	print $messages{$lang}[9];
}

elsif($next_step == 11) {
	print '<FORM action="';
	print $self;
	print '" method="POST" enctype="multipart/form-data">';
	print '<INPUT type="hidden" name="ac" value="2"><INPUT type="hidden" name="se" value="', $session, '">';
	print '<input type="hidden" name="lang" value="', $lang, '">';
	print '<div align="center"><table>';
	print '<tr><td colspan="2" align="left"><h2>', $messages{$lang}[11], '</h2></td></tr>';
	print '<tr><td align="right">', $messages{$lang}[12], ':</td>';
	print '<td align="left"><INPUT type="input" name="pseudo"></td></tr>';
	print '<tr><td>&nbsp;</td><td align="left">(', $messages{$lang}[13], ')</td></tr>';
	print '<tr><td colspan="2">&nbsp;</td></tr><tr><td align="right">', $messages{$lang}[14], ': </td>';
	print '<td align="left"><INPUT type="password" name="pw1"></td></tr>';
	print '<tr><td align="right">', $messages{$lang}[14], ': </td>';
	print '<td align="left"><INPUT type="password" name="pw2"></td></tr>';
	print '<tr><td>&nbsp;</td><td align="left">', $messages{$lang}[15], '</td></tr>';
	print '<tr><td></td><td align="left"><br><INPUT type="submit" value="', $messages{$lang}[16];
	print '"><br><br></td></tr>';
	print '<tr><td align="right"></td><td align="left">', $messages{$lang}[17], ':<br>';
	print '<br>WEB: https://', $self_host, '/<span style="color: #4B006D;">pseudonym</span>.msg';
	if(defined($onion_host)) {
		print '<br>TOR: http://', $onion_host, '/<span style="color: #4B006D;">pseudonym</span>.msg';
	}
	if(defined($i2p_host)) {
		print '<br>I2P:&nbsp;&nbsp;&nbsp;http://', $i2p_host, '/<span style="color: #4B006D;">pseudonym</span>.msg</td></tr>';
	}
	print '</table></div></FORM>';
}

elsif($next_step == 12) {
	print $messages{$lang}[18], '<br><br>';
	print $messages{$lang}[19];
}

elsif($next_step == 100) {
	if($lang eq 'de') {
		# Der deutsche Teil
		print 'Um ein Postfach mit einer Kontaktseite anzulegen und zu nutzen, ist eine Anmeldung erforderlich.';
		print ' Mit der Anmeldung akzeptieren Sie die <a href="index.html#nutzen">Nutzungsbedingungen</a>.';
		print '<br><br>';
		print 'Die Angabe einer Kontaktadresse ist <strong>freiwillig</strong>. Bitte beachten Sie, dass wir Ihnen bei ';
		print 'einem vergessenen Passwort o.&#228; nur helfen können, wenn wir Sie als Inhaber des Accounts verifizieren ';
		print 'können. Wir können Sie anhand einer signierten Nachricht verifizieren (wenn Sie OpenPGP nutzen) oder anhand ';
		print 'der Kontaktadresse.<br><br><br>';
		print '<div align="center">';
		print '<form action="/cgi-bin/tram_neu.pl" method="POST" target="_self" ENCTYPE="multipart/form-data">';
		print '<input type="hidden" name="ac" value="1">';
		print '<input type="hidden" name="lang" value="de">';
		print 'Wie können wir Sie ereichen? (Telefon, IM, E-Mail, I2P-Mail...)<br>';
		print '<input type="text" name="erreichen" tabindex="1" size="65"><br>';
		print '<span style="font-size:12px;">Die Kontaktadresse wird verschl&#252;sselt gespeichert. Nur die Administratoren<br>';
		print 'haben Zugriff auf diese Information, um Sie bei Verlust des Passwortes<br>';
		print 'als Inhaber des Accounts zu verifizieren und Ihnen zu helfen.</span><br><br>';
		print '<input type="submit" VALUE="N&#228;chster Schritt -&#187;" tabindex="2"></form></div>';
	} elsif ($lang eq 'fr') {
		# Der französische Teil
		print 'Pour utiliser l&apos;interface de contact en ligne, ou le service de courrier &eacute;lectronique, vous devez pr&eacute;alablement cr&eacute;er un compte.';
		print '<br><br>';
		print 'Il n&apos;est pas obligatoire de d&eacute;finir des coordonn&eacute;es de contact.';
		print ' Mais dans l&apos;hypoth&egrave;se o&ugrave; vous perdriez votre mot de passe, ou quoi que ce soit ';
		print 'du m&ecirc;me ordre, nous ne pourrions vous aider qu&apos;&agrave; la seule condition de pouvoir ';
		print 'v&eacute;rifier l&apos;identit&eacute; du titulaire du compte en question. ';
		print 'Nous pouvons v&eacute;rifier votre identit&eacute; par l&apos;interm&eacute;diaire d&apos;un message';
		print ' authentifi&eacute; via OpenPGP (si vous l&apos;utilisez) ou par le biais de vos coordonn&eacute;es de contact.';
		print '<br><br><br>';
		print '<div align="center">';
		print '<form action="/cgi-bin/tram_neu.pl" method="POST" target="_self" ENCTYPE="multipart/form-data">';
		print '<input type="hidden" name="ac" value="1">';
		print '<input type="hidden" name="lang" value="fr">';
		print 'Vos coordonn&eacute;es de contact (fon, messagerie instantan&eacute;e, e-mail, i2pmail...)<br>';
		print '<input type="text" name="erreichen" tabindex="1" size="65"><br>';
		print '<span style="font-size:12px;">Vos coordonn&eacute;es de contact seront stock&eacute;es sous forme chiffr&eacute;e.<br>';
		print 'Seuls les administrateurs du service ont acc&egrave;s &agrave; la cl&eacute; de d&eacute;cryptage de ces informations,<br>pour le cas o&ugrave; cette proc&eacute;dure s&apos;av&eacute;rerait indispensable &agrave; vous venir en assistance.</span><br><br>';
		print '<input type="submit" VALUE="&Eacute;tape suivante -&#187;" tabindex="2"></form></div>';
	} else {
		# Der englische Teil
		print 'To use a contact web page and postbox, you have to create an account.<br><br>';
		print 'It is <strong>not nessecary</strong> to set a contact address. But if your password was lost or something ';
		print 'else, we can help you only, if we could verify the identity of the user of an account. We may verify your ';
		print 'identity by an OpenPGP signed message (if you were using OpenPGP) or by your contact address.<br><br><br>';
		print '<div align="center">';
		print '<form action="/cgi-bin/tram_neu.pl" method="POST" target="_self" ENCTYPE="multipart/form-data">';
		print '<input type="hidden" name="ac" value="1">';
		print '<input type="hidden" name="lang" value="en">';
		print 'Your contact address (fon, instant messaging, e-mail, i2p-mail...)<br>';
		print '<input type="text" name="erreichen" tabindex="1" size="65"><br>';
		print '<span style="font-size:12px;">Your contact address will be saved encrypted. Only the admins of<br>the ';
		print 'service may decrypt this information, if it was nessecary to help you.</span><br><br>';
		print '<input type="submit" VALUE="next step -&#187;" tabindex="2"></form></div>';
	}
}

print '</div></div></body></html>';

