#!/usr/bin/perl -w

use CGI;
use CGI::Carp qw(fatalsToBrowser);

use integer;

$query = new CGI;

# The default main directory
my $maindir= '/privacybox/';

# Message translations
my %messages = (
     de => [ 'Unbekannter Empf&#228;nger!',
             'Das Postfach von ist voll, es können keine Nachrichten mehr gespeichert werden.',
             'Bitte geben Sie einen kurzen &#034;Betreff&#034; für die Nachricht an.',
             'Die Nachricht enth&#228;lt keinen Text!',
             'Interner Fehler!<br>Die Nachricht wurde NICHT gespeichert.',
             'Die Nachricht wurde gespeichert.',
             'Die Nachricht wurde NICHT gespeichert!<br>Der Name der angeh&#228;ngten Datei ist suspect, bitte benennen Sie die Datei um und senden Sie die Nachricht erneut.',
             'Das Postfach ist noch nicht konfiguriert! Es werden keine Nachrichten angenommen.',
             'Zeit&#252;berschreitung, die Nachricht wurde NICHT gespeichert.',
             'Fehlerhafte Daten gesendet!',
             #10
             'Empf&#228;nger',
             'Mobile-Version',
             'Betreff',
             'Desktop-Version',
             'Text der Nachricht',
             'Datei anh&#228;ngen',
             'max. 600kB',
             'Nachricht senden',
             'PrivacyBox',
             'Wird unverschl&#252;sselt gespeichert!',
             #20
             'Wird mit OpenPGP oder S/MIME verschl&#252;sselt.',
             'Die Nachricht wird anonym gespeichert. Bitte geben Sie im Text der<br>Nachricht eine <strong>Kontaktadresse</strong> an, wenn Sie eine Antwort erwarten.',
             'Die Software erkennt OpenPGP-konform verschl&#252;sselte Texte und Anh&#228;nge und wird diese nicht zus&#228;tzlich verschl&#252;sseln. Wenn Sie einen OpenPGP-Schl&#252;ssel des Empf&#228;ngers im Keyring haben, nutzen Sie die M&#246;glichkeit, den Text und den Anhang selbst zu verschl&#252;sseln. Eine kurze Anleitung f&#252;r <a href="https://www.awxcnx.de/handbuch_32q.htm" target="_blank">den Nachrichtentext</a> und <a href="https://www.awxcnx.de/handbuch_35p.htm" target="_blank">die Anh&#228;nge</a> stellen wir bereit.',
             'Scheinbar versuchen Sie, eine HTML-Mail zu faken.',
             'Die Nachricht enth&#228;lt unzul&#228;ssige HTML-Tags.',
             'Wird f&#252;r diesen Empf&#228;nger nicht verschl&#252;sselt.',
             'Bescheibung',
             'Anmelden',
             'Login',
             'Kontakt',
             # 30
             'Tor-Web-Proxy',
             'mehr'
           ],
     en => [ 'Unknown recipient!',
             'The postbox of this acoount is full. You can not send a new messages.',
             'Please write a short subject of the message.',
             'The message does not contain any text.',
             'Internal error, the message was not saved.',
             'Your message is saved.',
             'Your message was NOT saved!<br>Please rename the attached file and try again.',
             'The postbox is not configured yet. You can not send a new message to this account.',
             'Session timeout, the message was NOT saved.',
             'Wrong data sent.',
             # 10
             'recipient',
             'mobile version',
             'subject',
             'desktop version',
             'message text',
             'attach a file',
             'max. 600kB',
             'send message',
             'PrivacyBox',
             'not encrypted',
             # 20
             'Will be encrypted with OpenPGP or S/MIME.',
             'The message will be saved without any information about the sender.<br>
              Please give a <strong>contact information</strong> in the message text for a response.',
             'The software recognices OpenPGP encrypted message text and encrypted files. If it was possible for you, please encrypt the message text and the attached file.',
             'It seems, you want to fake a HTML mail.',
             'The message contains bad HTML tags.',
             'Not encrypted for this recipient.',
             'Description',
             'Sign Up',
             'Login',
             'Contact',
             # 30
             'Tor web proxy',
             'more'
           ],

      fr => [ 'recepien inconnu!',
              'La messagerie est plain. Vous pouvez pas enovoyer des nouvels messages.',
              'Vieullez &eacute;crire un subjet pour le message.',
              'Le message ne contien pas du text.',
              'Erreur intern, le message n&apos;a pas &eacute;t&eacute; sauvegarder.',
              'Votre message es sauvegarder.',
              'Le message n&apos;a pas &eacute;t&eacute; sauvegarder!<br>Vieullez renommer la pi&egrave;ce et essayer a nouveau.',
              'La messagerie n&apos;a pas &eacute;t&eacute; configurer actuellement. Vous pouvez pas envoyer des nouvels messages &aacute; cette messagerie.',
              'La s&eacute;ance a &eacute;te cl&ocirc;turer, le message n&apos;est pas sauvegarder.',
              'Des faux dates envoyer.',
              'd&eacute;stinataire',
              'version mobile',
              'subjet',
              'version bureau',
              'texte message',
              'ajout&eacute; une pi&egrave;ce',
              'max. 600kB',
              'envoyer message',
              'PrivacyBox',
              'non crypt&eacute;',
              'Vas &eacute;tre envoyer par OpenPGP ou S/MIME.',
              'La message vas &eacute;tre sauvegarder sans information &aacute; propos de l&apos;envoyeur.<br>Laissez s&apos;il vous pla&icirc;t un <strong>contact d&apos;information</strong> pour une reponse.',
              'Le logiciel reconna&icirc;t les messages et pi&egrave;ce attaché crypt&eacute; par OpenPGP. Si c&apos;est possible pour vous, crypt&eacute; vos messages et pi&egrave;ce attach&eacute; vous m&ecirc;me.',
              'Il para&icirc;t que vous vouliez manipul&eacute; une message HTML.',
              'Ce message contient du faux code HTML.',
              'Non crypt&eacute; pour ce receveur.',
              'Description du service',
              'Inscription',
              'Connexion',
              'Contact',
              'proxy web TOR',
              'poursuit'
          ]
    );

# read the PBox main config file /etc/privacybox.conf, if exist
if (-e '/etc/privacybox.conf') {
	open (FILE, '/etc/privacybox.conf');
	my $line=0;
	while (<FILE>) {
		$line++;
		chomp;
		s/#.*//;
		s/^\s*//;
		s/\s*$//;
		next unless $_;

		my ($key, $value) = split(/\s+/, $_, 2);
		$key = lc($key);

		if($key eq 'pbox_main_dir') { $maindir= $value; }
	}
}

# Set the sub directories of the privacybox
if(!($maindir =~ /\/$/)) { $maindir= $maindir . '/'; }
my $cgi_conf= $maindir . 'cgi-conf/pbox.conf';

# define the params
my $self_host= undef;
my $onion_host= undef;
my $i2p_host= undef;

# read the params from config file
open (FILE, $cgi_conf);
my $line=0;
while (<FILE>) {
	$line++;
	chomp;
	s/#.*//;
	s/^\s*//;
	s/\s*$//;
	next unless $_;
	my ($key, $value) = split(/\s+/, $_, 2);
	$key = lc($key);
	next unless defined $value;

	if ($key eq 'host_name' ) {
		$self_host = $value;
	} elsif ($key eq 'onion_name' ) {
		$onion_host = $value;
	} elsif ($key eq 'i2p_name' ) {
		$i2p_host = $value;
	}
}


# the hostname of the server and URL of the script
my $conntyp= 0;
my $addr= $ENV{'REMOTE_ADDR'};
my $hostname= $ENV{'HTTP_HOST'};
if ( $hostname=~ /\.onion$/ ) { 
	$hostname= 'http://' . $hostname; 
	$conntyp= 11;
} elsif ( $hostname=~ /\.i2p$/ ) { 
	$hostname= 'http://' . $hostname; 
	$conntyp= 12;
} else { 
	$hostname= 'https://' . $hostname; 
	# check for JonDonym
	if (($addr eq '80.237.152.53')||($addr eq '141.76.45.35')||($addr eq '141.76.45.34')||
		($addr eq '212.227.103.74')||($addr eq '87.118.100.175')||($addr eq '80.237.191.141')||
		($addr eq '80.237.191.139')||($addr eq '87.230.56.32')||($addr eq '64.202.107.25')||
		($addr eq '193.164.133.197')||($addr eq '80.190.200.171')||($addr eq '87.230.56.74')||
		($addr eq '195.2.228.226')) { 
		$conntyp= 3;
	} else {
		$conntyp= 0;
	}
}
my $self= $hostname . $ENV{'SCRIPT_NAME'};

# bevorzugte Sprache ermitteln
my $lang= $query->param('lang');
if ((!(defined($lang)))  || ($lang eq "") || (!defined($messages{$lang}[0]))) { 
	my $tmplang= $ENV{'HTTP_ACCEPT_LANGUAGE'};
	if(defined($tmplang)) {
		if($tmplang =~ /^de/) { $lang= 'de'; }
		elsif($tmplang =~ /^fr/) { $lang= 'fr'; }
		else { $lang= 'en'; }
	} else { $lang= 'de'; }
}

my $step= $query->param('ac');
if(( $step ne '1' ) && ($step ne '2' )) { $step= '1'; }

print "Content-type: text/html\n\n";
# HTML-Kopf schreiben
print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"><html>';
print '<head><title>PrivacyBox</title>  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">';
print '<meta http-equiv="expires" content="0">';
print '<meta NAME="robots" content="noindex,nofollow"><meta http-equiv="Content-Style-Type" content="text/css">';
print '<LINK rel="StyleSheet" type="text/css" href="/pbox.css">';
print '</head><body><div id="all"><div id="head">';

print '<h1>', $messages{$lang}[18], '</h1></div>'; 

# Auswahl der Sprache für das Formular
print '<div id="language_selection">';
print '<a href="', $self, '?ac=1&amp;lang=en">';
print '<img src="/images/en.png" hspace="5" vspace="0" alt="english" width="24" height="16" border="0"></a>', "\n";
print '<a href="', $self, '?ac=1&amp;lang=de">';
print '<img src="/images/de.png" hspace="5" vspace="0" alt="deutsch" width="24" height="16" border="0"></a>', "\n";
print '<a href="', $self, '?ac=1&amp;lang=fr">';
print '<img src="/images/fr.png" hspace="5" vspace="0" alt="fran&ccedil;ais" width="24" height="16" border="0"></a>';
print '</div>';

print '<div id="anonymous_use">';
if($lang eq 'de') {
	# Der deutsche Hinweis auf die Hidden Services
	print 'Sie können die Kontaktseite anonym und unbeobachtet mit '; 
	if ($conntyp == 3) { print '<span class="anonymous_active">JonDonym</span>'; }
	else { print '<a href="https://www.jondos.de/de/" class="anonymous_use_link">JonDonym</a>'; }
	print ' nutzen.<br> Die Kontaktseite ist auch als ';
	if ($conntyp == 11) { print '<span class="anonymous_active">Tor&nbsp;Hidden&nbsp;Service</span>'; } 
	else { print '<a href="http://', $onion_host, '/cgi-bin/tram_sample.pl?ac=1&amp;lang=de" class="anonymous_use_link">Tor&nbsp;Hidden&nbsp;Service</a>'; }
	print ' und ';
	if ($conntyp == 12) { print '<span class="anonymous_active">I2P&nbsp;eepsite</span>'; } 
	else { print '<a href="http://', $i2p_host, '/cgi-bin/tram_sample.pl?ac=1&amp;lang=de" class="anonymous_use_link">I2P&nbsp;eepsite</a>'; }
	print ' erreichbar.';

} elsif ($lang eq 'fr') {
	# Der Hinweis auf die Hidden Services in Französisch
	print 'Nous vous conseillons d&apos;utiliser ce service, anonyme et intra&ccedil;able, par ';
	if ($conntyp == 3) {  print '<span class="anonymous_active">JonDonym</span>'; }
	else { print '<a href="https://www.jondos.de/en/" class="anonymous_use_link">JonDonym</a>'; }
	print ', par ';
	if ($conntyp == 11) { print '<span class="anonymous_active">l&apos;interm&eacute;diaire&nbsp;du&nbsp;service&nbsp;TOR</span>'; } 
	else { print '<a href="http://' , $onion_host , '/cgi-bin/tram_sample.pl?ac=1&amp;lang=fr" class="anonymous_use_link">l&apos;interm&eacute;diaire&nbsp;duvservice&nbsp;TOR</a>'; }
	print ' en ';
	if ($conntyp == 12) { print '<span class="anonymous_active">tant&nbsp;que&nbsp;site&nbsp;I2P</span>'; } 
	else { print '<a href="http://', $i2p_host, '/cgi-bin/tram_sample.pl?ac=1&amp;lang=fr" class="anonymous_use_link">tant&nbsp;que&nbsp;site&nbsp;I2P</a>'; }
	print ' ou avec un <a href="https://www.awxcnx.de/cgi-bin/proxy4/nph-proxy.cgi/000000A/http/privacybox.i2p/cgi-bin/tram_sample.pl?ac=1&amp;lang=fr" class="anonymous_use_link">proxy&nbsp;web&nbsp;I2P</a>.';

} else {
	# Der englische Hinweis auf die Hidden Services
	print 'You may use this contact page anonymous and not traceable by ';
	if ($conntyp == 3) { print '<span class="anonymous_active">JonDonym</span>'; }
	else { print ' <a href="https://www.jondos.de/en/" class="anonymous_use_link">JonDonym</a>'; }
	print '.<br>';
  print 'This contact page ist accessible by ';
	if ($conntyp == 11) { print '<span class="anonymous_active">Tor&nbsp;hidden&nbsp;service</span>'; } 
	else { print '<a href="http://', $onion_host, '/cgi-bin/tram_sample.pl?ac=1&amp;lang=en" class="anonymous_use_link">Tor&nbsp;hidden&nbsp;service</a>'; }
	print ' or ';
	if ($conntyp == 12) { print '<span class="anonymous_active">I2P&nbsp;eepsite</span>'; } 
	else { print '<a href="http://', $i2p_host, '/cgi-bin/tram_sample.pl?ac=1&amp;lang=en" class="anonymous_use_link">I2P&nbsp;eepsite</a>'; }
	print ' too.';
}
print '</div>';

print '<div id="wirspeichernnichtlogo"><a href="http://www.wirspeichernnicht.de/content/view/10/22/">';
print '<IMG src="/images/wirspeichernnichtsiegel_d.png" width="109" height="113" border="0"></a></div>';

print '<div id="navigation"><div id="navigation_pbox">';
print '<a href="/index.', $lang , '.html" class="navigation_pbox_link">', $messages{$lang}[26], '</a> &nbsp; ';
print '<a href="/cgi-bin/tram_neu.pl?lang=', $lang ,'&amp;ac=0" class="navigation_pbox_link">', $messages{$lang}[27], '</a> &nbsp; ';
print '<a href="/cgi-bin/tram_login.pl?ac=0&amp;lang=', $lang ,'" class="navigation_pbox_link">', $messages{$lang}[28], '</a> &nbsp; '; 
print '<a href="/cgi-bin/tram_msg.pl?sus=admin&amp;lang=', $lang ,'" class="navigation_pbox_link">', $messages{$lang}[29], '</a>'; 
print '</div><div id="navigation_webservices">';
print '<a href="/tor-proxy.', $lang ,'.html" class="navigation_webservices_link">', $messages{$lang}[30], '</a> &nbsp; ';
print '<a href="/tor-proxy.', $lang ,'.html" class="navigation_webservices_link">', $messages{$lang}[31], '&nbsp;&raquo;</a>';
print '</div></div><div id="content">';


if( $step eq '2' ) {
	print '<div class="info">';
	if($lang eq 'de') {
		print 'Das Formular ist nur ein Beispiel. Hier passiert wirklich nichts.';
	} else {
		print 'This form is only a sample. Nothing took place here.';
	}
	print '</div>';

} else {
	# write the sample form
	my $eencryption= '1';
	print '<form action="', $self ,'" method="POST" target="_self" ENCTYPE="multipart/form-data">';
	print '<INPUT type="hidden" name="ac" value="2">';
	print '<INPUT type="hidden" name="lang" value="', $lang, '">';
	print '<div align="center"><table>';
	print '<tr><td align="right">', $messages{$lang}[10], ':</td><td  align="left"> <strong>sample</strong></td></tr>';
	print '<tr><td align="right">', $messages{$lang}[12], ':<br><br><br></td>';
	print '<td align="left"><input type="text" name="betreff" tabindex="1" size="35%"><br>';
	print '<span style="font-size:12px;">(', $messages{$lang}[19], ')</span><br><br></td>';
	print '</tr><tr><td colspan="2">',$messages{$lang}[14], ': <span style="font-size:12px;">(';
	if($eencryption eq '0') { print $messages{$lang}[25]; }
	else { print $messages{$lang}[20]; }
	print ')</span> <br>';
	print '<textarea rows="10" cols="70" name="artikel" tabindex="2"></textarea><br>';
	print $messages{$lang}[21], '<br><br>';
	print '</TD></TR><tr><TD align="right">', $messages{$lang}[15], ':<br>(', $messages{$lang}[16], ')&nbsp;&nbsp;<br><br></td>';
	print '<td align="left"><input type="file" name="andatei" accept="*/*" maxlength="656600" tabindex="3"><br>';
	print '<span style="font-size:12px;">(';
	if($eencryption eq '0') { print $messages{$lang}[25]; }
	else { print $messages{$lang}[20]; }
	print ')</span></TD>';
	print '</tr></table></div><br>';
	print '<input type="submit" VALUE="', $messages{$lang}[17], '"  tabindex="4"><br><br></form>';
	print '<strong>End-to-End-Encryption:</strong> ', $messages{$lang}[22]; 
	print '<br><br>';
}

print '</div></div></body></html>';



